/**
This file is part of a project licensed under the GNU General Public License v3.
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.
This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
GNU General Public License for more details.
You should have received a copy of the GNU General Public License
along with this program. If not, see <https://www.gnu.org/licenses/>.
*/

<template>
  <div class="card">
    <header class="card-header">
      <div class="card-header-title">{{ $t("Select Version") }}</div>
      <div class="card-header-icon">
        <button @click="$parent.close()" class="delete is-large"></button>
      </div>
    </header>
    <div class="card-content">
      <a>
        <b-field grouped group-multiline>
          <div v-for="(column, index) in columns" :key="index" class="control">
            <b-checkbox v-model="column.display">
              {{ column.label }}
            </b-checkbox>
          </div>
        </b-field>
        <b-table
          :data="this.tabelValues"
          :paginated="true"
          :hoverable="true"
          :selected.sync="selectedVersion"
          @click="selected"
          :per-page="itemsPerPage"
        >
          <template slot-scope="tabelValues">
            <b-table-column
              v-for="(column, index) in columns"
              :key="index"
              :label="column.label"
              :field="column.field"
              :visible="column.display"
              :numeric="column.numeric"
              :searchable="column.searchable"
              :sortable="column.sortable"
            >
              <template
                v-if="column.searchable && !column.numeric"
                slot="searchable"
                slot-scope="props"
              >
                <b-input
                  v-model="props.filters[props.column.field]"
                  placeholder="Filter..."
                  icon="filter"
                  size="is-small"
                />
              </template>
              {{ tabelValues.row[column.field] }}
            </b-table-column>
          </template>
        </b-table>
      </a>
    </div>
  </div>
</template>
<style scoped>
.center {
  text-align: center;
}
table tr:hover td {
  color: white !important;
}
</style>

<script>
export default {
  data() {
    return {
      itemsPerPage: 10,
      columns: [
        {
          field: "tsId",
          label: this.$t("Transcription-Id"),
          numeric: true,
          sortable: true,
          searchable: true,
          display: false,
        },
        {
          field: "status",
          label: this.$t("Status"),
          numeric: false,
          searchable: true,
          sortable: true,
          display: true,
        },
        {
          field: "userName",
          label: this.$t("User name"),
          searchable: true,
          sortable: true,
          display: true,
        },
        {
          field: "toolName",
          label: this.$t("Toolname"),
          numeric: false,
          sortable: true,
          searchable: true,
          display: true,
        },
      ],
    };
  },
  props: {
    tsList: Object,
    versionIndex: Number,
  },
  computed: {
    tabelValues() {
      return this.tsList.transcripts;
    },
    selectedVersion() {
      return this.tsList.transcripts[this.versionIndex];
    },
  },
  methods: {
    selected(item) {
      this.$emit("closeModal", item);
    },
  },
};
</script>
